<template>
	<a-drawer
		:title="formData.id ? '编辑离线报警' : '增加离线报警'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="企业客户：" name="depotId" v-if="!formData.depotId">
				<a-select v-model:value="formData.depotId" placeholder="请选择企业客户" :options="depotIdOptions"/>
			</a-form-item>
			<a-form-item label="设备名称：" name="deviceName">
				<a-input v-model:value="formData.deviceName" placeholder="请输入设备名称" allow-clear/>
			</a-form-item>
			<a-form-item label="设备编号：" name="deviceTax">
				<a-input v-model:value="formData.deviceTax" placeholder="请输入设备编号" allow-clear/>
			</a-form-item>
			<a-form-item label="在线时间：" name="onlineTime">
				<a-input v-model:value="formData.onlineTime" placeholder="请输入在线时间" allow-clear/>
			</a-form-item>
			<a-form-item label="异常信息：" name="alarmMsg">
				<a-input v-model:value="formData.alarmMsg" placeholder="请输入异常信息" allow-clear/>
			</a-form-item>
			<a-form-item label="处理状态：" name="saveState">
				<a-radio-group v-model:value="formData.saveState" placeholder="请选择处理状态" :options="saveStateOptions"/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotDeviceWarnForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import depotDeviceWarnApi from '@/api/biz/depotDeviceWarnApi'
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const depotIdOptions = ref([])
const saveStateOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	} else {
		depotIdOptions.value = tool.dictList('depotId')
	}
	saveStateOptions.value = tool.dictList('处理状态')
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			formDataParam.saveState = JSON.stringify(formDataParam.saveState)
			depotDeviceWarnApi
				.depotDeviceWarnSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
